
#line 3 "nd-flow-criteria.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 4
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

#ifdef yyget_lval
#define yyget_lval_ALREADY_DEFINED
#else
#define yyget_lval yyget_lval
#endif

#ifdef yyset_lval
#define yyset_lval_ALREADY_DEFINED
#else
#define yyset_lval yyset_lval
#endif

#ifdef yyget_lloc
#define yyget_lloc_ALREADY_DEFINED
#else
#define yyget_lloc yyget_lloc
#endif

#ifdef yyset_lloc
#define yyset_lloc_ALREADY_DEFINED
#else
#define yyset_lloc yyset_lloc
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#ifndef SIZE_MAX
#define SIZE_MAX               (~(size_t)0)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* begin standard C++ headers. */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an
 *   integer in range [0..255] for use as an array index.
 */
#define YY_SC_TO_UI(c) ((YY_CHAR) (c))

/* An opaque pointer. */
#ifndef YY_TYPEDEF_YY_SCANNER_T
#define YY_TYPEDEF_YY_SCANNER_T
typedef void* yyscan_t;
#endif

/* For convenience, these vars (plus the bison vars far below)
   are macros in the reentrant scanner. */
#define yyin yyg->yyin_r
#define yyout yyg->yyout_r
#define yyextra yyg->yyextra_r
#define yyleng yyg->yyleng_r
#define yytext yyg->yytext_r
#define yylineno (YY_CURRENT_BUFFER_LVALUE->yy_bs_lineno)
#define yycolumn (YY_CURRENT_BUFFER_LVALUE->yy_bs_column)
#define yy_flex_debug yyg->yy_flex_debug_r

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yyg->yy_start = 1 + 2 *
/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yyg->yy_start - 1) / 2)
#define YYSTATE YY_START
/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin , yyscanner )
#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2
    
    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex.
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    #define YY_LINENO_REWIND_TO(dst) \
            do {\
                const char *p;\
                for ( p = yy_cp-1; p >= (dst); --p)\
                    if ( *p == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = yyg->yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yyg->yy_c_buf_p = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )
#define unput(c) yyunput( c, yyg->yytext_ptr , yyscanner )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( yyg->yy_buffer_stack \
                          ? yyg->yy_buffer_stack[yyg->yy_buffer_stack_top] \
                          : NULL)
/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE yyg->yy_buffer_stack[yyg->yy_buffer_stack_top]

void yyrestart ( FILE *input_file , yyscan_t yyscanner );
void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer , yyscan_t yyscanner );
YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size , yyscan_t yyscanner );
void yy_delete_buffer ( YY_BUFFER_STATE b , yyscan_t yyscanner );
void yy_flush_buffer ( YY_BUFFER_STATE b , yyscan_t yyscanner );
void yypush_buffer_state ( YY_BUFFER_STATE new_buffer , yyscan_t yyscanner );
void yypop_buffer_state ( yyscan_t yyscanner );

static void yyensure_buffer_stack ( yyscan_t yyscanner );
static void yy_load_buffer_state ( yyscan_t yyscanner );
static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file , yyscan_t yyscanner );
#define YY_FLUSH_BUFFER yy_flush_buffer( YY_CURRENT_BUFFER , yyscanner)

YY_BUFFER_STATE yy_scan_buffer ( char *base, yy_size_t size , yyscan_t yyscanner );
YY_BUFFER_STATE yy_scan_string ( const char *yy_str , yyscan_t yyscanner );
YY_BUFFER_STATE yy_scan_bytes ( const char *bytes, int len , yyscan_t yyscanner );

void *yyalloc ( yy_size_t , yyscan_t yyscanner );
void *yyrealloc ( void *, yy_size_t , yyscan_t yyscanner );
void yyfree ( void * , yyscan_t yyscanner );

#define yy_new_buffer yy_create_buffer
#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE , yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}
#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE , yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}
#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(yyscanner) (/*CONSTCOND*/1)
#define YY_SKIP_YYWRAP
typedef flex_uint8_t YY_CHAR;

typedef int yy_state_type;

#define yytext_ptr yytext_r

static yy_state_type yy_get_previous_state ( yyscan_t yyscanner );
static yy_state_type yy_try_NUL_trans ( yy_state_type current_state  , yyscan_t yyscanner);
static int yy_get_next_buffer ( yyscan_t yyscanner );
static void yynoreturn yy_fatal_error ( const char* msg , yyscan_t yyscanner );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yyg->yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yyg->yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yyg->yy_c_buf_p = yy_cp;
#define YY_NUM_RULES 90
#define YY_END_OF_BUFFER 91
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static const flex_int16_t yy_accept[532] =
    {   0,
        0,    0,   91,   89,   88,   88,   89,   89,   89,   89,
       79,   79,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   88,   81,    0,    0,
       84,    0,    0,    0,   79,   73,    0,    0,    0,   83,
       80,   82,    0,    0,    0,   87,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,   87,
        0,    0,    0,    0,    0,    0,    0,    0,   87,   86,
        0,    0,    0,    0,    0,   79,   73,    0,    0,   73,
       73,   78,   71,   85,    0,    0,   32,   36,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,   85,   76,    0,
       74,    0,    0,    0,   79,    0,   73,   72,    0,   66,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,   66,    0,    0,   76,
        0,    0,   74,    0,    0,   79,   73,   67,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,   47,   38,
        0,    0,    0,    0,    0,    0,    0,    0,    0,   77,

       75,    0,    0,   73,    0,   35,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,   65,    0,   28,    0,
        0,    0,    0,   61,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,   70,    0,   73,
        0,    0,    0,    0,    0,   26,    0,    0,    0,   30,
        0,   27,    2,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,   58,    0,   60,    0,
        0,    4,    0,   70,   73,    0,    0,   37,    0,    0,
        0,    0,    0,   29,    0,    0,   15,    0,    0,    0,

        0,    0,    0,    0,    0,   16,    0,    0,    0,    0,
        0,    0,    0,    0,   49,   46,    0,    0,    0,    0,
       59,    0,    0,    0,    0,   69,   70,   73,    0,    0,
        0,    0,    0,    0,    0,    0,    0,   13,    0,    0,
        0,    0,    0,    0,    0,    0,   14,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,   73,    0,    0,    0,    0,    0,    0,
        0,    0,    3,   17,    0,    0,    0,    0,    0,    0,
        0,    0,   18,    0,    5,    0,    0,    0,    0,    0,
        0,   55,    0,   57,    0,   21,    0,    0,   73,    0,

       33,    0,    0,    0,    0,    0,    0,    0,    0,    1,
        0,    0,    0,    0,    0,    0,   12,    8,    0,    0,
        0,    0,    0,    0,   48,    0,   54,   56,   20,   19,
       73,   43,    0,    0,    0,    0,    0,    0,   53,   45,
        0,    0,    0,    0,   62,   63,    0,    0,    0,   11,
        0,    0,    0,    0,    0,   73,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        6,    0,    0,    0,    0,   73,    0,   34,    0,    0,
        0,   24,    0,    0,    0,    0,    0,   64,    0,    0,
        0,   51,    0,   31,   73,    0,    0,    0,    0,    0,

       44,    0,   39,    0,   10,    9,    0,    0,   73,    0,
        0,    0,    0,    0,   40,   41,    0,    0,   68,    0,
       52,    0,   23,   25,    7,   50,    0,   22,    0,   42,
        0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    1,    1,    1,    7,    8,    9,
        9,    1,    9,    1,    9,   10,   11,   12,   13,   14,
       14,   15,   14,   14,   14,   14,   14,   16,    1,   17,
       18,   19,    1,    1,   20,   21,   21,   22,   23,   24,
       25,   25,   25,   25,   25,   26,   25,   27,   28,   25,
       25,   29,   30,   31,   32,   25,   25,   25,   25,   25,
        1,    1,    1,    1,   33,    1,   34,   35,   36,   37,

       38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
       48,   49,   25,   50,   51,   52,   53,   54,   55,   56,
       57,   25,    1,   58,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const YY_CHAR yy_meta[59] =
    {   0,
        1,    1,    2,    3,    1,    1,    1,    1,    3,    4,
        5,    6,    6,    6,    6,    7,    1,    1,    1,    6,
        6,    6,    6,    6,    8,    8,    8,    8,    8,    8,
        8,    8,    3,    6,    6,    6,    6,    6,    6,    8,
        8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
        8,    8,    8,    8,    8,    9,    8,    1
    } ;

static const flex_int16_t yy_base[555] =
    {   0,
        0,    0,  852,  853,   57,   60,  833,  800,  842,  798,
       55,   62,  831,  828,  827,  826,   63,   70,   62,   37,
       54,  794,   64,   67,   75,   47,  793,  793,  803,   77,
      789,  796,   49,   87,  792,  114,  147,  853,    0,  780,
      853,    0,  779,  140,  153,  112,   83,    0,  821,  853,
      853,  853,  102,  160,  130,  853,  104,  784,  128,  161,
      796,  780,  784,  780,  792,  781,  793,  789,  775,  781,
      781,  773,  769,  780,  773,  766,  769,  781,  126,  159,
      808,   97,  805,  166,  180,  187,  131,   91,  194,  801,
      800,    0,  853,  853,  168,  187,  178,  772,  771,  775,

      774,  181,  764,  772,  770,  183,  769,  760,  761,  762,
      747,  754,  745,  763,  762,  747,  746,  198,  853,  256,
      853,  314,  226,  238,  253,  776,  162,  264,  232,  853,
      147,  749,  750,  753,  747,  746,  750,  743,  734,  742,
      732,  730,  746,  729,  740,  732,  743,  733,  724,  725,
      721,  738,  180,  244,  732,  736,  248,  762,  372,  761,
      758,  430,  757,  279,  754,  287,  211,  853,  729,  725,
      725,  712,  707,  716,  709,  722,  708,  191,  712,  709,
      716,  699,  702,  699,  715,  697,  699,  712,   97,  853,
      707,  701,  704,  699,  195,  706,  701,  693,  695,  730,

      727,  295,  313,  231,  682,  853,  699,  682,  243,  679,
      679,  677,  695,  690,  679,  673,  853,  675,  853,  671,
      671,  288,  679,  687,  454,  218,  671,  676,  668,  666,
      666,  673,  666,  697,  661,  677,  672,  327,  698,  272,
      669,  654,  648,  667,  655,  853,  650,  663,  664,  853,
      659,  853,  853,  650,  655,  647,  661,  646,  642,  298,
      642,  641,  641,  641,  190,  640,  649,  629,  638,  650,
      646,  637,  630,  639,  628,  637,  853,  635,  853,  625,
      265,  853,  335,  341,  302,  635,  632,  853,  640,  625,
      624,  630,  635,  853,  632,  619,  853,  630,  615,  620,

      615,  610,  614,  612,  609,  853,  622,  621,  611,  605,
      608,  604,  252,  600,  853,  618,  599,  611,  606,  609,
      853,  604,  593,  596,  586,  345,  631,  313,  593,  592,
      598,  605,  603,  588,  583,  586,  586,  853,  580,  598,
      594,  588,  584,  593,  578,  591,  853,  572,  571,  574,
      583,  573,  566,  580,  325,  579,  566,  567,  564,  565,
      532,  525,  511,  352,  501,  497,  489,  329,  474,  467,
      475,  464,  853,  853,  208,  471,  464,  454,  461,  447,
      450,  452,  853,  441,  853,  443,  441,  447,  452,  448,
      448,  853,  436,  853,  435,  853,  443,  442,  359,  422,

      445,  426,  428,  422,  427,  424,  434,  414,  430,  853,
      424,  259,  423,  417,  418,  429,  853,  853,  428,  425,
      407,  412,  412,  407,  853,  406,  853,  853,  853,  853,
      365,  853,  350,  405,  410,  417,  412,  416,  853,  853,
      404,  409,  402,  396,  853,  853,  390,  410,  409,  853,
      395,  393,  390,  401,  386,  372,  399,  392,  381,  378,
      375,  373,  390,  373,  384,  371,  366,  372,  367,  366,
      853,  366,  358,  374,  363,  382,  360,  853,  377,  365,
      358,  853,  356,  350,  359,  367,  366,  853,  351,  350,
      349,  853,  349,  853,  383,  358,  341,  347,  346,  328,

      853,  312,  853,  312,  853,  853,  307,  294,  384,  296,
      297,  259,  267,  247,  853,  853,  235,  178,  176,  111,
      853,  108,  853,  853,  853,  853,   67,  853,   35,  853,
      853,  502,  506,  512,  519,  526,  532,  535,   75,  539,
      542,  549,  558,  563,  570,  579,  584,  587,  590,  593,
      596,  599,  602,  605
    } ;

static const flex_int16_t yy_def[555] =
    {   0,
      531,    1,  531,  531,  531,  531,  531,  532,  531,  533,
      534,  534,  531,  531,  531,  531,  534,  534,   17,  531,
      531,   17,   19,   17,  534,   19,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  535,  535,
      531,  536,  536,  531,  537,  538,  537,  539,  531,  531,
      531,  531,  531,  537,  531,  531,  531,  531,  537,  537,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      535,  535,  536,  536,  531,  540,  541,  540,  531,  538,
      538,  539,  531,  531,  531,  531,  531,  531,  531,  531,

      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  542,
      531,  543,  531,  531,  531,  531,  544,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  545,  542,  545,
      546,  543,  546,  531,  531,  531,  538,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  545,

      546,  531,  531,  547,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  548,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  538,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,

      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  549,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  550,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  538,  531,

      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      551,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  552,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  538,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  553,  531,  531,  531,  531,  531,

      531,  531,  531,  531,  531,  531,  531,  531,  554,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  538,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
        0,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531
    } ;

static const flex_int16_t yy_nxt[912] =
    {   0,
        4,    5,    6,    5,    7,    8,    9,   10,    4,    4,
        4,   11,   12,   12,   12,   13,   14,   15,   16,   17,
       18,   18,   18,   19,    4,    4,    4,   20,    4,    4,
       21,    4,    4,   22,   18,   23,   24,   25,   26,    4,
        4,   27,    4,    4,   28,    4,   29,   30,   31,   32,
       33,   34,    4,   35,    4,    4,    4,   36,   37,   37,
       37,   37,   37,   37,   44,   56,   45,   45,   45,   45,
       46,   44,  531,   45,   45,   45,   45,   46,   46,  531,
       92,   54,   57,   47,  531,   46,   56,   65,  531,   53,
       46,  530,  531,  531,   56,   54,   74,   59,   87,   75,

      531,   66,  119,   57,   60,   56,   46,   61,  531,   53,
       48,   57,  120,   62,   63,   57,  529,  531,  531,   55,
       53,  531,   89,   94,  531,  531,   70,   91,   71,  226,
       64,   76,  227,   55,   56,   96,   57,  531,   94,   77,
       53,   89,   79,   87,   57,  528,   91,   55,   37,   37,
       37,   85,   85,   85,   85,   95,   96,   96,  527,   94,
       53,   96,   44,   79,   86,   86,   86,   86,   87,  531,
      531,   80,   89,  121,   95,   87,   87,   90,   96,   98,
       94,  122,  169,   96,   95,   95,   89,   95,  170,  123,
       96,  124,  124,  124,  124,   94,   44,  129,  125,  125,

      125,  125,   46,   95,   95,  128,  128,  128,  128,  130,
      131,   96,   99,  137,  138,  192,  118,   95,  129,  142,
      130,   89,  132,  308,  130,  129,  204,  129,  214,  143,
      232,  144,  215,  193,  526,  130,  145,  164,  164,  164,
      164,   89,  309,  411,  130,  233,   90,  123,  129,  165,
      165,  165,  165,  270,  168,  157,  158,  158,  412,  271,
      158,  160,  158,  158,  166,  166,  166,  166,   46,  168,
      168,  525,  158,  158,  158,  128,  128,  128,  128,  194,
      244,  195,   89,  524,  245,  168,  196,   90,  202,  168,
      203,  203,  203,  203,  443,  352,  444,  197,  166,  166,

      166,  166,  353,  523,  323,  168,  238,  238,  238,  238,
      522,  324,   89,  158,  161,  161,  325,  328,  161,  161,
      161,  163,  202,   89,  239,  239,  239,  239,   90,  256,
      161,  161,  161,  257,  521,  520,  258,  283,  284,  284,
      284,  284,  301,  518,  517,  302,  326,  326,  326,  326,
      303,  283,  327,  327,  327,  327,  326,  326,  326,  326,
      389,  516,   89,  515,  403,  514,  390,   90,  404,   89,
      405,  161,  158,  158,  431,   89,  158,  160,  158,  158,
       90,  406,   89,  513,  512,  457,  511,   90,  158,  158,
      158,  458,   89,   89,   89,  510,  508,  495,   90,   90,

      507,  506,  505,  504,  503,  502,  501,  500,  499,  498,
      497,  496,  494,  493,  492,  491,  490,  489,  488,  487,
      486,  485,  484,  483,  482,  481,  480,  479,  478,  158,
      161,  161,  477,  475,  161,  161,  161,  163,  474,  473,
      472,  471,  470,  469,  468,  467,  161,  161,  161,  466,
      465,  464,  463,  462,  461,  460,  459,  455,  454,  453,
      452,  451,  450,  449,  448,  447,  446,  445,  442,  441,
      440,  439,  438,  437,  436,  435,  434,  433,  432,  430,
      429,  428,  427,  426,  425,  424,  423,  161,  261,  422,
      421,  262,  420,  419,  418,  263,  417,  416,  264,  265,

      415,  414,  266,  267,  413,  268,  269,   39,  410,   39,
       39,   42,  409,   42,   42,   47,  408,   47,   47,  407,
       47,   81,   81,   81,   81,   81,   81,   81,   83,   83,
       83,   83,   83,   83,   83,   88,  402,   88,   88,   90,
       90,   90,  126,  401,  126,  126,  127,  127,  127,  159,
      400,  159,  159,  159,  159,  159,  159,  159,  162,  398,
      162,  162,  162,  162,  162,  162,  162,  167,  167,  167,
      158,  397,  158,  158,  158,  158,  158,  158,  158,  161,
      396,  161,  161,  161,  161,  161,  161,  161,  240,  240,
      240,  285,  285,  285,  364,  364,  364,  399,  399,  399,

      456,  456,  456,  476,  476,  476,  509,  509,  509,  519,
      519,  519,  395,  394,  393,  392,  391,  388,  387,  386,
      385,  384,  383,  382,  381,  380,  379,  378,  377,  376,
      375,  374,  373,  372,  371,  370,  369,  368,  367,  366,
      365,  283,  363,  362,  361,  360,  359,  358,  357,  356,
      355,  354,  351,  350,  349,  348,  347,  346,  345,  344,
      343,  342,  341,  340,  339,  338,  337,  336,  335,  334,
      333,  332,  331,  330,  329,  322,  321,  320,  319,  318,
      317,  316,  315,  314,  313,  312,  311,  310,  307,  306,
      305,  304,  300,  299,  298,  297,  296,  295,  294,  293,

      292,  291,  290,  289,  288,  287,  286,  202,  282,  281,
      280,  279,  278,  277,  276,  275,  274,  273,  272,  260,
      259,  255,  254,  253,  252,  251,  250,  249,  248,  247,
      246,  243,  242,  241,  201,  200,  237,  236,  235,  234,
      231,  230,  229,  228,  225,  224,  223,  222,  221,  220,
      219,  218,  217,  216,  213,  212,  211,  210,  209,  208,
      207,  206,  205,  123,  201,  201,  200,  200,  199,  198,
      191,  190,  189,  188,  187,  186,  185,  184,  183,  182,
      181,  180,  179,  178,  177,  176,  175,  174,  173,  172,
      171,   46,  156,  155,  154,  153,  152,  151,  150,  149,

      148,  147,  146,  141,  140,  139,  136,  135,  134,  133,
       89,   89,  121,  119,  117,  116,  115,  114,  113,  112,
      111,  110,  109,  108,  107,  106,  105,  104,  103,  102,
      101,  100,   97,   93,   84,   82,   78,   73,   72,   69,
       68,   67,   58,   52,   51,   50,   49,   43,   41,   40,
       38,  531,    3,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,

      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531
    } ;

static const flex_int16_t yy_chk[912] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    5,    5,
        5,    6,    6,    6,   11,   20,   11,   11,   11,   11,
       11,   12,   17,   12,   12,   12,   12,   12,   17,   18,
      539,   19,   21,   23,   25,   18,   20,   26,   19,   17,
       25,  529,   47,   24,   20,   19,   33,   23,   47,   33,

       88,   26,   82,   21,   24,   30,   88,   24,   19,   17,
       11,   21,   82,   24,   24,   34,  527,   12,   17,   19,
       17,   23,   46,   53,   24,   18,   30,   46,   30,  189,
       25,   34,  189,   36,   30,   57,   34,   59,   53,   34,
       36,   87,   36,   59,   34,  522,   87,   36,   37,   37,
       37,   44,   44,   44,   44,   55,   57,   79,  520,   53,
       36,   57,   45,   36,   45,   45,   45,   45,   45,   54,
       60,   36,  127,   84,   55,   54,   60,  127,   79,   59,
       80,   84,  131,   79,   80,   54,  519,   55,  131,   85,
       80,   85,   85,   85,   85,   80,   86,   95,   86,   86,

       86,   86,   86,   80,   54,   89,   89,   89,   89,   96,
       97,   80,   60,  102,  102,  153,   80,   54,   95,  106,
      118,  167,   97,  265,   96,   95,  167,  118,  178,  106,
      195,  106,  178,  153,  518,  118,  106,  123,  123,  123,
      123,  204,  265,  375,   96,  195,  204,  124,  118,  124,
      124,  124,  124,  226,  129,  118,  120,  120,  375,  226,
      120,  120,  120,  120,  125,  125,  125,  125,  125,  129,
      157,  517,  120,  120,  120,  128,  128,  128,  128,  154,
      209,  154,  240,  514,  209,  157,  154,  240,  164,  129,
      164,  164,  164,  164,  412,  313,  412,  154,  166,  166,

      166,  166,  313,  513,  281,  157,  202,  202,  202,  202,
      512,  281,  285,  120,  122,  122,  281,  285,  122,  122,
      122,  122,  203,  328,  203,  203,  203,  203,  328,  222,
      122,  122,  122,  222,  511,  510,  222,  238,  238,  238,
      238,  238,  260,  508,  507,  260,  283,  283,  283,  283,
      260,  284,  284,  284,  284,  284,  326,  326,  326,  326,
      355,  504,  364,  502,  368,  500,  355,  364,  368,  399,
      368,  122,  159,  159,  399,  431,  159,  159,  159,  159,
      431,  368,  456,  499,  498,  433,  497,  456,  159,  159,
      159,  433,  476,  495,  509,  496,  493,  476,  495,  509,

      491,  490,  489,  487,  486,  485,  484,  483,  481,  480,
      479,  477,  475,  474,  473,  472,  470,  469,  468,  467,
      466,  465,  464,  463,  462,  461,  460,  459,  458,  159,
      162,  162,  457,  455,  162,  162,  162,  162,  454,  453,
      452,  451,  449,  448,  447,  444,  162,  162,  162,  443,
      442,  441,  438,  437,  436,  435,  434,  426,  424,  423,
      422,  421,  420,  419,  416,  415,  414,  413,  411,  409,
      408,  407,  406,  405,  404,  403,  402,  401,  400,  398,
      397,  395,  393,  391,  390,  389,  388,  162,  225,  387,
      386,  225,  384,  382,  381,  225,  380,  379,  225,  225,

      378,  377,  225,  225,  376,  225,  225,  532,  372,  532,
      532,  533,  371,  533,  533,  534,  370,  534,  534,  369,
      534,  535,  535,  535,  535,  535,  535,  535,  536,  536,
      536,  536,  536,  536,  536,  537,  367,  537,  537,  538,
      538,  538,  540,  366,  540,  540,  541,  541,  541,  542,
      365,  542,  542,  542,  542,  542,  542,  542,  543,  363,
      543,  543,  543,  543,  543,  543,  543,  544,  544,  544,
      545,  362,  545,  545,  545,  545,  545,  545,  545,  546,
      361,  546,  546,  546,  546,  546,  546,  546,  547,  547,
      547,  548,  548,  548,  549,  549,  549,  550,  550,  550,

      551,  551,  551,  552,  552,  552,  553,  553,  553,  554,
      554,  554,  360,  359,  358,  357,  356,  354,  353,  352,
      351,  350,  349,  348,  346,  345,  344,  343,  342,  341,
      340,  339,  337,  336,  335,  334,  333,  332,  331,  330,
      329,  327,  325,  324,  323,  322,  320,  319,  318,  317,
      316,  314,  312,  311,  310,  309,  308,  307,  305,  304,
      303,  302,  301,  300,  299,  298,  296,  295,  293,  292,
      291,  290,  289,  287,  286,  280,  278,  276,  275,  274,
      273,  272,  271,  270,  269,  268,  267,  266,  264,  263,
      262,  261,  259,  258,  257,  256,  255,  254,  251,  249,

      248,  247,  245,  244,  243,  242,  241,  239,  237,  236,
      235,  234,  233,  232,  231,  230,  229,  228,  227,  224,
      223,  221,  220,  218,  216,  215,  214,  213,  212,  211,
      210,  208,  207,  205,  201,  200,  199,  198,  197,  196,
      194,  193,  192,  191,  188,  187,  186,  185,  184,  183,
      182,  181,  180,  179,  177,  176,  175,  174,  173,  172,
      171,  170,  169,  165,  163,  161,  160,  158,  156,  155,
      152,  151,  150,  149,  148,  147,  146,  145,  144,  143,
      142,  141,  140,  139,  138,  137,  136,  135,  134,  133,
      132,  126,  117,  116,  115,  114,  113,  112,  111,  110,

      109,  108,  107,  105,  104,  103,  101,  100,   99,   98,
       91,   90,   83,   81,   78,   77,   76,   75,   74,   73,
       72,   71,   70,   69,   68,   67,   66,   65,   64,   63,
       62,   61,   58,   49,   43,   40,   35,   32,   31,   29,
       28,   27,   22,   16,   15,   14,   13,   10,    9,    8,
        7,    3,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,

      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531
    } ;

/* Table of booleans, true if rule could match eol. */
static const flex_int32_t yy_rule_can_match_eol[91] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,     };

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
#line 1 "nd-flow-criteria.l"
#define YY_NO_INPUT 1
#line 7 "nd-flow-criteria.l"
// Netify Agent
// Copyright (C) 2015-2024 eGloo Incorporated <http://www.egloo.ca>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#include "nd-flow-parser.h"

#include "nd-flow-expr.hpp"
#line 881 "nd-flow-criteria.c"
#line 882 "nd-flow-criteria.c"

#define INITIAL 0

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* Holds the entire state of the reentrant scanner. */
struct yyguts_t
    {

    /* User-defined. Not touched by flex. */
    YY_EXTRA_TYPE yyextra_r;

    /* The rest are the same as the globals declared in the non-reentrant scanner. */
    FILE *yyin_r, *yyout_r;
    size_t yy_buffer_stack_top; /**< index of top of stack. */
    size_t yy_buffer_stack_max; /**< capacity of stack. */
    YY_BUFFER_STATE * yy_buffer_stack; /**< Stack as an array. */
    char yy_hold_char;
    int yy_n_chars;
    int yyleng_r;
    char *yy_c_buf_p;
    int yy_init;
    int yy_start;
    int yy_did_buffer_switch_on_eof;
    int yy_start_stack_ptr;
    int yy_start_stack_depth;
    int *yy_start_stack;
    yy_state_type yy_last_accepting_state;
    char* yy_last_accepting_cpos;

    int yylineno_r;
    int yy_flex_debug_r;

    char *yytext_r;
    int yy_more_flag;
    int yy_more_len;

    YYSTYPE * yylval_r;

    YYLTYPE * yylloc_r;

    }; /* end struct yyguts_t */

static int yy_init_globals ( yyscan_t yyscanner );

    /* This must go here because YYSTYPE and YYLTYPE are included
     * from bison output in section 1.*/
    #    define yylval yyg->yylval_r
    
    #    define yylloc yyg->yylloc_r
    
int yylex_init (yyscan_t* scanner);

int yylex_init_extra ( YY_EXTRA_TYPE user_defined, yyscan_t* scanner);

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy ( yyscan_t yyscanner );

int yyget_debug ( yyscan_t yyscanner );

void yyset_debug ( int debug_flag , yyscan_t yyscanner );

YY_EXTRA_TYPE yyget_extra ( yyscan_t yyscanner );

void yyset_extra ( YY_EXTRA_TYPE user_defined , yyscan_t yyscanner );

FILE *yyget_in ( yyscan_t yyscanner );

void yyset_in  ( FILE * _in_str , yyscan_t yyscanner );

FILE *yyget_out ( yyscan_t yyscanner );

void yyset_out  ( FILE * _out_str , yyscan_t yyscanner );

			int yyget_leng ( yyscan_t yyscanner );

char *yyget_text ( yyscan_t yyscanner );

int yyget_lineno ( yyscan_t yyscanner );

void yyset_lineno ( int _line_number , yyscan_t yyscanner );

int yyget_column  ( yyscan_t yyscanner );

void yyset_column ( int _column_no , yyscan_t yyscanner );

YYSTYPE * yyget_lval ( yyscan_t yyscanner );

void yyset_lval ( YYSTYPE * yylval_param , yyscan_t yyscanner );

       YYLTYPE *yyget_lloc ( yyscan_t yyscanner );
    
        void yyset_lloc ( YYLTYPE * yylloc_param , yyscan_t yyscanner );
    
/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap ( yyscan_t yyscanner );
#else
extern int yywrap ( yyscan_t yyscanner );
#endif
#endif

#ifndef YY_NO_UNPUT
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy ( char *, const char *, int , yyscan_t yyscanner);
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen ( const char * , yyscan_t yyscanner);
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput ( yyscan_t yyscanner );
#else
static int input ( yyscan_t yyscanner );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg , yyscanner)
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex \
               (YYSTYPE * yylval_param, YYLTYPE * yylloc_param , yyscan_t yyscanner);

#define YY_DECL int yylex \
               (YYSTYPE * yylval_param, YYLTYPE * yylloc_param , yyscan_t yyscanner)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

    yylval = yylval_param;

    yylloc = yylloc_param;

	if ( !yyg->yy_init )
		{
		yyg->yy_init = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yyg->yy_start )
			yyg->yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack (yyscanner);
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer( yyin, YY_BUF_SIZE , yyscanner);
		}

		yy_load_buffer_state( yyscanner );
		}

	{
#line 32 "nd-flow-criteria.l"

#line 1166 "nd-flow-criteria.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yyg->yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yyg->yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yyg->yy_start;
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				yyg->yy_last_accepting_state = yy_current_state;
				yyg->yy_last_accepting_cpos = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 532 )
					yy_c = yy_meta[yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 853 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = yyg->yy_last_accepting_cpos;
			yy_current_state = yyg->yy_last_accepting_state;
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					
    do{ yylineno++;
        yycolumn=0;
    }while(0)
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = yyg->yy_hold_char;
			yy_cp = yyg->yy_last_accepting_cpos;
			yy_current_state = yyg->yy_last_accepting_state;
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 33 "nd-flow-criteria.l"
return FLOW_IP_PROTO;
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 34 "nd-flow-criteria.l"
return FLOW_IP_DSCP;
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 35 "nd-flow-criteria.l"
return FLOW_IP_VERSION;
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 36 "nd-flow-criteria.l"
return FLOW_VLAN_ID;
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 37 "nd-flow-criteria.l"
return FLOW_OTHER_TYPE;
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 38 "nd-flow-criteria.l"
yylval->us_number = _NDFP_OTHER_UNKNOWN; return FLOW_OTHER_UNKNOWN;
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 39 "nd-flow-criteria.l"
yylval->us_number = _NDFP_OTHER_UNSUPPORTED; return FLOW_OTHER_UNSUPPORTED;
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 40 "nd-flow-criteria.l"
yylval->us_number = _NDFP_OTHER_LOCAL; return FLOW_OTHER_LOCAL;
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 41 "nd-flow-criteria.l"
yylval->us_number = _NDFP_OTHER_MULTICAST; return FLOW_OTHER_MULTICAST;
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 42 "nd-flow-criteria.l"
yylval->us_number = _NDFP_OTHER_BROADCAST; return FLOW_OTHER_BROADCAST;
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 43 "nd-flow-criteria.l"
yylval->us_number = _NDFP_OTHER_REMOTE; return FLOW_OTHER_REMOTE;
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 44 "nd-flow-criteria.l"
yylval->us_number = _NDFP_OTHER_ERROR; return FLOW_OTHER_ERROR;
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 45 "nd-flow-criteria.l"
return FLOW_LOCAL_MAC;
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 46 "nd-flow-criteria.l"
return FLOW_OTHER_MAC;
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 47 "nd-flow-criteria.l"
return FLOW_LOCAL_IP;
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 48 "nd-flow-criteria.l"
return FLOW_OTHER_IP;
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 49 "nd-flow-criteria.l"
return FLOW_LOCAL_PORT;
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 50 "nd-flow-criteria.l"
return FLOW_OTHER_PORT;
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 51 "nd-flow-criteria.l"
return FLOW_TUNNEL_TYPE;
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 52 "nd-flow-criteria.l"
yylval->us_number = _NDFP_TUNNEL_NONE; return FLOW_TUNNEL_NONE;
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 53 "nd-flow-criteria.l"
yylval->us_number = _NDFP_TUNNEL_GTP; return FLOW_TUNNEL_GTP;
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 54 "nd-flow-criteria.l"
return FLOW_DETECTION_COMPLETE;
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 55 "nd-flow-criteria.l"
return FLOW_DETECTION_GUESSED;
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 56 "nd-flow-criteria.l"
return FLOW_DETECTION_INIT;
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 57 "nd-flow-criteria.l"
return FLOW_DETECTION_UPDATED;
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 58 "nd-flow-criteria.l"
return FLOW_DHC_HIT;
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 59 "nd-flow-criteria.l"
return FLOW_FHC_HIT;
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 60 "nd-flow-criteria.l"
return FLOW_IP_NAT;
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 61 "nd-flow-criteria.l"
return FLOW_EXPIRING;
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 62 "nd-flow-criteria.l"
return FLOW_EXPIRED;
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 63 "nd-flow-criteria.l"
return FLOW_SOFT_DISSECTOR;
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 64 "nd-flow-criteria.l"
return FLOW_APPLICATION;
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 65 "nd-flow-criteria.l"
return FLOW_APPLICATION;
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 66 "nd-flow-criteria.l"
return FLOW_APPLICATION;
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 67 "nd-flow-criteria.l"
return FLOW_APPLICATION;
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 68 "nd-flow-criteria.l"
return FLOW_CATEGORY;
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 69 "nd-flow-criteria.l"
return FLOW_CATEGORY;
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 70 "nd-flow-criteria.l"
return FLOW_RISKS;
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 71 "nd-flow-criteria.l"
return FLOW_NDPI_RISK_SCORE;
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 72 "nd-flow-criteria.l"
return FLOW_NDPI_RISK_SCORE_CLIENT;
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 73 "nd-flow-criteria.l"
return FLOW_NDPI_RISK_SCORE_SERVER;
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 74 "nd-flow-criteria.l"
return FLOW_APPLICATION_CATEGORY;
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 75 "nd-flow-criteria.l"
return FLOW_APPLICATION_CATEGORY;
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 76 "nd-flow-criteria.l"
return FLOW_DOMAIN_CATEGORY;
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 77 "nd-flow-criteria.l"
return FLOW_DOMAIN_CATEGORY;
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 78 "nd-flow-criteria.l"
return FLOW_PROTOCOL;
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 79 "nd-flow-criteria.l"
return FLOW_PROTOCOL;
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 80 "nd-flow-criteria.l"
return FLOW_PROTOCOL;
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 81 "nd-flow-criteria.l"
return FLOW_PROTOCOL;
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 82 "nd-flow-criteria.l"
return FLOW_PROTOCOL_CATEGORY;
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 83 "nd-flow-criteria.l"
return FLOW_PROTOCOL_CATEGORY;
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 84 "nd-flow-criteria.l"
return FLOW_DETECTED_HOSTNAME;
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 85 "nd-flow-criteria.l"
return FLOW_DNS_HOSTNAME;
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 86 "nd-flow-criteria.l"
return FLOW_TLS_VERSION;
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 87 "nd-flow-criteria.l"
return FLOW_TLS_CIPHER;
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 88 "nd-flow-criteria.l"
return FLOW_TLS_VERSION;
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 89 "nd-flow-criteria.l"
return FLOW_TLS_CIPHER;
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 90 "nd-flow-criteria.l"
return FLOW_TLS_ECH;
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 91 "nd-flow-criteria.l"
return FLOW_TLS_ESNI;
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 92 "nd-flow-criteria.l"
return FLOW_TLS_JA4;
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 93 "nd-flow-criteria.l"
return FLOW_ORIGIN;
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 94 "nd-flow-criteria.l"
yylval->us_number = _NDFP_ORIGIN_LOCAL; return FLOW_ORIGIN_LOCAL;
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 95 "nd-flow-criteria.l"
yylval->us_number = _NDFP_ORIGIN_OTHER; return FLOW_ORIGIN_OTHER;
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 96 "nd-flow-criteria.l"
yylval->us_number = _NDFP_ORIGIN_UNKNOWN; return FLOW_ORIGIN_UNKNOWN;
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 97 "nd-flow-criteria.l"
return FLOW_CT_MARK;
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 98 "nd-flow-criteria.l"
yylval->bool_number=true; return VALUE_TRUE;
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 99 "nd-flow-criteria.l"
yylval->bool_number=false; return VALUE_FALSE;
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 100 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_ADDR_MAC;
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 101 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_ADDR_IPV4_CIDR;
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 102 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_ADDR_IPV4;
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 103 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_ADDR_IPV6;
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 104 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_ADDR_IPV6_CIDR;
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 105 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_ADDR_IPV6;
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 106 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_NAME;
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 107 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_REGEX;
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 108 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_NAME;
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 109 "nd-flow-criteria.l"
strncpy(yylval->buffer, yytext, _NDFP_MAX_BUFLEN); return VALUE_REGEX;
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 110 "nd-flow-criteria.l"
yylval->ul_number=(unsigned long)strtold(yytext, NULL); return VALUE_NUMBER;
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 111 "nd-flow-criteria.l"
yylval->ul_number=(unsigned long)strtold(yytext, NULL); return VALUE_NUMBER;
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 112 "nd-flow-criteria.l"
return CMP_EQUAL;
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 113 "nd-flow-criteria.l"
return CMP_NOTEQUAL;
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 114 "nd-flow-criteria.l"
return CMP_GTHANEQUAL;
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 115 "nd-flow-criteria.l"
return CMP_LTHANEQUAL;
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 116 "nd-flow-criteria.l"
return BOOL_AND;
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 117 "nd-flow-criteria.l"
return BOOL_AND;
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 118 "nd-flow-criteria.l"
return BOOL_OR;
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 119 "nd-flow-criteria.l"
return BOOL_OR;
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 120 "nd-flow-criteria.l"
/* Skip whitespace */
	YY_BREAK
case 89:
YY_RULE_SETUP
#line 121 "nd-flow-criteria.l"
return (int)yytext[0];
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 122 "nd-flow-criteria.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 1686 "nd-flow-criteria.c"
case YY_STATE_EOF(INITIAL):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yyg->yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yyg->yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yyg->yy_c_buf_p <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yyg->yy_c_buf_p = yyg->yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state( yyscanner );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state , yyscanner);

			yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yyg->yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yyg->yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer( yyscanner ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yyg->yy_did_buffer_switch_on_eof = 0;

				if ( yywrap( yyscanner ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yyg->yy_c_buf_p = yyg->yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yyg->yy_c_buf_p =
					yyg->yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yyg->yy_c_buf_p =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars];

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = yyg->yytext_ptr;
	int number_to_move, i;
	int ret_val;

	if ( yyg->yy_c_buf_p > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yyg->yy_c_buf_p - yyg->yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yyg->yy_c_buf_p - yyg->yytext_ptr - 1);

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) (yyg->yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc( (void *) b->yy_ch_buf,
							 (yy_size_t) (b->yy_buf_size + 2) , yyscanner );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yyg->yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			yyg->yy_n_chars, num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	if ( yyg->yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin  , yyscanner);
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yyg->yy_n_chars + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = yyg->yy_n_chars + number_to_move + (yyg->yy_n_chars >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size , yyscanner );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
		/* "- 2" to take care of EOB's */
		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
	}

	yyg->yy_n_chars += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yyg->yytext_ptr = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (yyscan_t yyscanner)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	yy_current_state = yyg->yy_start;

	for ( yy_cp = yyg->yytext_ptr + YY_MORE_ADJ; yy_cp < yyg->yy_c_buf_p; ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			yyg->yy_last_accepting_state = yy_current_state;
			yyg->yy_last_accepting_cpos = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 532 )
				yy_c = yy_meta[yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state , yyscan_t yyscanner)
{
	int yy_is_jam;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner; /* This var may be unused depending upon options. */
	char *yy_cp = yyg->yy_c_buf_p;

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		yyg->yy_last_accepting_state = yy_current_state;
		yyg->yy_last_accepting_cpos = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 532 )
			yy_c = yy_meta[yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	yy_is_jam = (yy_current_state == 531);

	(void)yyg;
	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (yyscan_t yyscanner)
#else
    static int input  (yyscan_t yyscanner)
#endif

{
	int c;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	*yyg->yy_c_buf_p = yyg->yy_hold_char;

	if ( *yyg->yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yyg->yy_c_buf_p < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			/* This was really a NUL. */
			*yyg->yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = (int) (yyg->yy_c_buf_p - yyg->yytext_ptr);
			++yyg->yy_c_buf_p;

			switch ( yy_get_next_buffer( yyscanner ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin , yyscanner);

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( yyscanner ) )
						return 0;

					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput(yyscanner);
#else
					return input(yyscanner);
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yyg->yy_c_buf_p = yyg->yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yyg->yy_c_buf_p;	/* cast for 8-bit char's */
	*yyg->yy_c_buf_p = '\0';	/* preserve yytext */
	yyg->yy_hold_char = *++yyg->yy_c_buf_p;

	if ( c == '\n' )
		
    do{ yylineno++;
        yycolumn=0;
    }while(0)
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * @param yyscanner The scanner object.
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack (yyscanner);
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer( yyin, YY_BUF_SIZE , yyscanner);
	}

	yy_init_buffer( YY_CURRENT_BUFFER, input_file , yyscanner);
	yy_load_buffer_state( yyscanner );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * @param yyscanner The scanner object.
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack (yyscanner);
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( yyscanner );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yyg->yy_did_buffer_switch_on_eof = 1;
}

static void yy_load_buffer_state  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	yyg->yytext_ptr = yyg->yy_c_buf_p = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	yyg->yy_hold_char = *yyg->yy_c_buf_p;
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * @param yyscanner The scanner object.
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state ) , yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2) , yyscanner );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file , yyscanner);

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * @param yyscanner The scanner object.
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree( (void *) b->yy_ch_buf , yyscanner );

	yyfree( (void *) b , yyscanner );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file , yyscan_t yyscanner)

{
	int oerrno = errno;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	yy_flush_buffer( b , yyscanner);

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * @param yyscanner The scanner object.
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( yyscanner );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  @param yyscanner The scanner object.
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack(yyscanner);

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		yyg->yy_buffer_stack_top++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( yyscanner );
	yyg->yy_did_buffer_switch_on_eof = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  @param yyscanner The scanner object.
 */
void yypop_buffer_state (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER , yyscanner);
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if (yyg->yy_buffer_stack_top > 0)
		--yyg->yy_buffer_stack_top;

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( yyscanner );
		yyg->yy_did_buffer_switch_on_eof = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (yyscan_t yyscanner)
{
	yy_size_t num_to_alloc;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if (!yyg->yy_buffer_stack) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		yyg->yy_buffer_stack = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		memset(yyg->yy_buffer_stack, 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		yyg->yy_buffer_stack_max = num_to_alloc;
		yyg->yy_buffer_stack_top = 0;
		return;
	}

	if (yyg->yy_buffer_stack_top >= (yyg->yy_buffer_stack_max) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = yyg->yy_buffer_stack_max + grow_size;
		yyg->yy_buffer_stack = (struct yy_buffer_state**)yyrealloc
								(yyg->yy_buffer_stack,
								num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset(yyg->yy_buffer_stack + yyg->yy_buffer_stack_max, 0, grow_size * sizeof(struct yy_buffer_state*));
		yyg->yy_buffer_stack_max = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return NULL;

	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state ) , yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = NULL;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b , yyscanner );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (const char * yystr , yyscan_t yyscanner)
{
    
	return yy_scan_bytes( yystr, (int) strlen(yystr) , yyscanner);
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (const char * yybytes, int  _yybytes_len , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = (yy_size_t) (_yybytes_len + 2);
	buf = (char *) yyalloc( n , yyscanner );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n , yyscanner);
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yynoreturn yy_fatal_error (const char* msg , yyscan_t yyscanner)
{
	struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	(void)yyg;
	fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = yyg->yy_hold_char; \
		yyg->yy_c_buf_p = yytext + yyless_macro_arg; \
		yyg->yy_hold_char = *yyg->yy_c_buf_p; \
		*yyg->yy_c_buf_p = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the user-defined data for this scanner.
 * @param yyscanner The scanner object.
 */
YY_EXTRA_TYPE yyget_extra  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyextra;
}

/** Get the current line number.
 * @param yyscanner The scanner object.
 */
int yyget_lineno  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        if (! YY_CURRENT_BUFFER)
            return 0;
    
    return yylineno;
}

/** Get the current column number.
 * @param yyscanner The scanner object.
 */
int yyget_column  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        if (! YY_CURRENT_BUFFER)
            return 0;
    
    return yycolumn;
}

/** Get the input stream.
 * @param yyscanner The scanner object.
 */
FILE *yyget_in  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyin;
}

/** Get the output stream.
 * @param yyscanner The scanner object.
 */
FILE *yyget_out  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyout;
}

/** Get the length of the current token.
 * @param yyscanner The scanner object.
 */
int yyget_leng  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyleng;
}

/** Get the current token.
 * @param yyscanner The scanner object.
 */

char *yyget_text  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yytext;
}

/** Set the user-defined data. This data is never touched by the scanner.
 * @param user_defined The data to be associated with this scanner.
 * @param yyscanner The scanner object.
 */
void yyset_extra (YY_EXTRA_TYPE  user_defined , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyextra = user_defined ;
}

/** Set the current line number.
 * @param _line_number line number
 * @param yyscanner The scanner object.
 */
void yyset_lineno (int  _line_number , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        /* lineno is only valid if an input buffer exists. */
        if (! YY_CURRENT_BUFFER )
           YY_FATAL_ERROR( "yyset_lineno called with no buffer" );
    
    yylineno = _line_number;
}

/** Set the current column.
 * @param _column_no column number
 * @param yyscanner The scanner object.
 */
void yyset_column (int  _column_no , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        /* column is only valid if an input buffer exists. */
        if (! YY_CURRENT_BUFFER )
           YY_FATAL_ERROR( "yyset_column called with no buffer" );
    
    yycolumn = _column_no;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param _in_str A readable stream.
 * @param yyscanner The scanner object.
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  _in_str , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyin = _in_str ;
}

void yyset_out (FILE *  _out_str , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyout = _out_str ;
}

int yyget_debug  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yy_flex_debug;
}

void yyset_debug (int  _bdebug , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yy_flex_debug = _bdebug ;
}

/* Accessor methods for yylval and yylloc */

YYSTYPE * yyget_lval  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yylval;
}

void yyset_lval (YYSTYPE *  yylval_param , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yylval = yylval_param;
}

YYLTYPE *yyget_lloc  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yylloc;
}
    
void yyset_lloc (YYLTYPE *  yylloc_param , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yylloc = yylloc_param;
}
    
/* User-visible API */

/* yylex_init is special because it creates the scanner itself, so it is
 * the ONLY reentrant function that doesn't take the scanner as the last argument.
 * That's why we explicitly handle the declaration, instead of using our macros.
 */
int yylex_init(yyscan_t* ptr_yy_globals)
{
    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }

    *ptr_yy_globals = (yyscan_t) yyalloc ( sizeof( struct yyguts_t ), NULL );

    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }

    /* By setting to 0xAA, we expose bugs in yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));

    return yy_init_globals ( *ptr_yy_globals );
}

/* yylex_init_extra has the same functionality as yylex_init, but follows the
 * convention of taking the scanner as the last argument. Note however, that
 * this is a *pointer* to a scanner, as it will be allocated by this call (and
 * is the reason, too, why this function also must handle its own declaration).
 * The user defined value in the first argument will be available to yyalloc in
 * the yyextra field.
 */
int yylex_init_extra( YY_EXTRA_TYPE yy_user_defined, yyscan_t* ptr_yy_globals )
{
    struct yyguts_t dummy_yyguts;

    yyset_extra (yy_user_defined, &dummy_yyguts);

    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }

    *ptr_yy_globals = (yyscan_t) yyalloc ( sizeof( struct yyguts_t ), &dummy_yyguts );

    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }

    /* By setting to 0xAA, we expose bugs in
    yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));

    yyset_extra (yy_user_defined, *ptr_yy_globals);

    return yy_init_globals ( *ptr_yy_globals );
}

static int yy_init_globals (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    yyg->yy_buffer_stack = NULL;
    yyg->yy_buffer_stack_top = 0;
    yyg->yy_buffer_stack_max = 0;
    yyg->yy_c_buf_p = NULL;
    yyg->yy_init = 0;
    yyg->yy_start = 0;

    yyg->yy_start_stack_ptr = 0;
    yyg->yy_start_stack_depth = 0;
    yyg->yy_start_stack =  NULL;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = NULL;
    yyout = NULL;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer( YY_CURRENT_BUFFER , yyscanner );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state(yyscanner);
	}

	/* Destroy the stack itself. */
	yyfree(yyg->yy_buffer_stack , yyscanner);
	yyg->yy_buffer_stack = NULL;

    /* Destroy the start condition stack. */
        yyfree( yyg->yy_start_stack , yyscanner );
        yyg->yy_start_stack = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( yyscanner);

    /* Destroy the main struct (reentrant only). */
    yyfree ( yyscanner , yyscanner );
    yyscanner = NULL;
    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, const char * s2, int n , yyscan_t yyscanner)
{
	struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	(void)yyg;

	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (const char * s , yyscan_t yyscanner)
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size , yyscan_t yyscanner)
{
	struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	(void)yyg;
	return malloc(size);
}

void *yyrealloc  (void * ptr, yy_size_t  size , yyscan_t yyscanner)
{
	struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	(void)yyg;

	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return realloc(ptr, size);
}

void yyfree (void * ptr , yyscan_t yyscanner)
{
	struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	(void)yyg;
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 122 "nd-flow-criteria.l"


